"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateAlarmBox = void 0;
const wordwrap_1 = __importDefault(require("wordwrap"));
const truncate = require("cli-truncate");
function ellipsys(a) {
    if (!a) {
        return "";
    }
    return truncate(a, 20, { position: "middle" });
}
function formatMultiline(s, width) {
    return (0, wordwrap_1.default)(80)(s).split("\n");
    let a = "";
    let r = [];
    for (const word of s.split(" ")) {
        if (a.length + word.length > width) {
            r.push(a);
            a = word;
        }
        else {
            a = a + " " + word;
        }
    }
    return r;
}
function n(a) {
    if (a === null || a === undefined) {
        return "";
    }
    return a.toString();
}
function f(flag) {
    return flag ? "X" : "_";
}
function updateAlarmBox(clientAlarms, alarmBox, headers) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        const data = [headers];
        for (const alarm of clientAlarms.alarms()) {
            const fields = alarm.fields;
            const isEnabled = fields.enabledState.id.value;
            const sourceName = (_a = fields.sourceName.value) === null || _a === void 0 ? void 0 : _a.toString();
            const m = formatMultiline(fields.message.value.text, 80);
            for (let i = 0; i < m.length; i++) {
                const aa = m[i];
                if (i === 0) {
                    data.push([
                        alarm.eventType.toString(),
                        alarm.conditionId.toString(),
                        sourceName,
                        // fields.branchId.value.toString(),
                        // ellipsys(alarm.eventId.toString("hex")),
                        isEnabled ? aa : "-",
                        isEnabled ? fields.severity.value + " (" + fields.lastSeverity.value + ")" : "-",
                        f(isEnabled) +
                            (isEnabled ? f(fields.activeState.id.value) : "-") +
                            (isEnabled ? f(fields.ackedState.id.value) : "-") +
                            (isEnabled ? f(fields.confirmedState.id.value) : "-"),
                        // (isEnabled ? f(fields.retain.value) : "-"),
                        isEnabled ? ellipsys(fields.comment.value.text) : "-",
                    ]);
                }
                else {
                    data.push([
                        "",
                        "",
                        "",
                        // fields.branchId.value.toString(),
                        // ellipsys(alarm.eventId.toString("hex")),
                        isEnabled ? aa : "-",
                        isEnabled ? "" : "-",
                        "",
                        // (isEnabled ? f(fields.retain.value) : "-"),
                        "",
                    ]);
                }
            }
        }
        alarmBox.setRows(data);
        alarmBox.screen.render();
    });
}
exports.updateAlarmBox = updateAlarmBox;
//# sourceMappingURL=alarm_box.js.map